// Prot386 Menu functions
// (C) 2006-2007 Peter Ambroz
// This code is free software and is distributed under the terms of GNU GPL

#include "prototypes.h"

char *def_u = 0, *def_d = 0;
extern int use_eol;
extern int pos_x;

void header(int lng, char *data) {
  int i,lft, rgt;

  rgt = lng-(strlen(data)+6);
  // strlen(data) == 0
  if (rgt == lng-6) {
    write("");
    for (i=0; i < lng-2; i++) write("");
    write("");
    return;
  }
  lft = rgt / 2;
  rgt = rgt-lft;
  write("");
  for (i=0; i < lft; i++) write("");
  write(" ");
  write(data);
  write(" ");
  for (i=0; i < rgt; i++) write("");
  write("");
}

void emptylines(int lng, int count) {
  int i,j;

  for (i=0; i < count; i++) {
    write("");
    for (j=0; j < lng-2; j++) write(" ");
    write("");
  }
}

void footer(int lng) {
  int i;

  write("");
  for (i=0; i < lng-2; i++) write("");
  write("");
}

void poz(char *u, char *d)
{
  int i,l1,l2;

  if (!u) {
    if (!def_u) return;
    u = def_u;
  } else def_u = u;
  if (!d) {
    if (!def_d) return;
    d = def_d;
  } else def_d = d;
  textattr=1;
  clearchar=0xB0;
  clrscr();
  textattr=112;
  gotoxy(0,24);
  write(d);
  l1=80-strlen(d);
  for (i=0; i<l1; i++) write(" ");
  gotoxy(0,0);
  l1=(80-strlen(u))/2;
  l2=80-strlen(u)-l1;
  for (i=0; i<l1; i++) write(" ");
  write(u);
  for (i=0; i<l2; i++) write(" ");
  return;
}

char *next_text(char *current) {
  while ((*current != '\n') && (*current)) current++;
  return ++current;
}

int menu(int x1, int x2, int y, int minlines, int color, int defitem, int spacing, ALIGN align, char *texts)
{
  static int ht=1;
  int h1,h2, items=0;
  int lng,lft,rgt;
  int i,j;
  int ch;

  if (defitem != -1) ht = defitem;
  use_eol = 1;
  i=0;
  while (texts[i]) {
    if (texts[i] == '\n') items++;
    i++;
  }
  textattr = color;
  window(x1, y, x2, y+items+spacing*(items+1)+2);
  lng = (x2-x1)+1;

  header(lng, texts);

  for (i=1; i <= items; i++) {
    texts = next_text(texts);
    switch(align) {
      case AL_CENTER:
        rgt = lng-(strlen(texts)+2);
        lft = rgt / 2;
        rgt = rgt-lft;
        break;
      default:
      case AL_LEFT:
        rgt = lng-(strlen(texts)+2);
        lft = 1;
        rgt = rgt-lft;
        break;
      case AL_RIGHT:
        lft = lng-(strlen(texts)+2);
        rgt = 1;
        lft = lft-rgt;
        break;
    }

    emptylines(lng, spacing);

    write("");
    for (j=0; j < lft; j++) write(" ");
    write(texts);
    for (j=0; j < rgt; j++) write(" ");
    write("");
  }

  if (items < minlines) emptylines(lng, (spacing+1)*(minlines-items));
  emptylines(lng, spacing);
  footer(lng);

  do {
   if (ht < 1) ht = items;
   if (ht > items) ht = 1;
   h1 = ht+1; if (h1 > items) h1 = 1;
   h2 = ht-1; if (h2 < 1) h2 = items;
   highlight(x1+1, x2-1, y+h1*(spacing+1), color);
   highlight(x1+1, x2-1, y+h2*(spacing+1), color);
   highlight(x1+1, x2-1, y+ht*(spacing+1), 31);
   ch=readkey();
   switch(ch) {
     case 72: ht--; break;
     case 80: ht++; break;
     case 1: ht = -1;
   }
  } while ((ch != 28) && (ch != 1));
  window(0,0,79,24);
  use_eol = 0;
  return ht;
}

// Menu with scrolling
int menu_ex(int x1, int x2, int y, int lines, int color, MENU_STATE *m, int items, char *title, char *(*getstr)(), void (*callback)() )
{
  int lng,h1,h2;
  static int ht=1,it=0;
  int i,j;
  int ch, scroll;
  char tmps[80];

  if (m) {
    ht = m->ht;
    it = m->it;
  }

  textattr = color;
  window(x1, y, x2, y+lines+2);
  lng = (x2-x1)+1;

  header(lng, title);
  emptylines(lng, lines);
  footer(lng);

  scroll = 1;

  do {
   if (ht < 1) { ht = 1; it--; scroll = 1; }
   if (ht > lines) { ht = lines; it++; scroll = 1; }
   if (it < 0) it+=items;
   if (it >= items) it-=items;

   if (scroll) {
     window(x1+2, y+1, x2-2, y+lines+1);
     for (i=0; i < lines; i++) {
       write(getstr(it+i,tmps));
       for (j=0; j < lng-(strlen(tmps)+4); j++) write(" ");
     }
   }

   scroll = 0;

   h1 = ht+1; if (h1 > lines) h1 = 1;
   h2 = ht-1; if (h2 < 1) h2 = lines;
   highlight(x1+1, x2-1, y+h1, color);
   highlight(x1+1, x2-1, y+h2, color);
   highlight(x1+1, x2-1, y+ht, 31);
   if (callback) callback((ht+it-1)%items);

   ch=readkey();
   switch(ch) {
     case 72: ht--; break;
     case 80: ht++; break;
     case 1: h2 = -1;
   }
  } while ((ch != 28) && (ch != 1));
  window(0,0,79,24);

  if (m) {
    m->ht = ht;
    m->it = it;
  }

  return h2==-1?-1:(it+ht-1)%items;
}

void okno(int x1, int x2, int y, int lines, int color, char *head, char *body)
{
  int lng;

  lng = (x2-x1)+1;
  textattr = color;
  window(x1, y, x2, y+lines+2);

  if (!head) {
    if (!body) return;
    use_eol = 1;
    header(lng, body);
    body = next_text(body);
    use_eol = 0;
  } else
    header(lng, head);
  emptylines(lng, lines);
  footer(lng);

  if (body) {
    window(x1+2, y+1, x2-2, y+lines+1);
    write(body);
  }
  window(0,0,79,24);
}

/* window with the generic parameters */
void okno_ex(char *body) {
  okno(19, 61, 10, 3, 79, "Exception", body);
}

/* Dialog box with text string input */
char *dialog(int x1, int x2, int y, int lines, int color, char *texts, char *dest)
{
  int lng;

  lng = (x2-x1)+1;
  textattr = color;
  window(x1, y, x2, y+lines+2);

  use_eol = 1;
  header(lng, texts);
  texts = next_text(texts);
  use_eol = 0;
  emptylines(lng, lines);
  footer(lng);

  window(x1+2, y+1, x2-2, y+lines+1);
  write(texts);
  read_string(dest, x2-pos_x-1);
  window(0,0,79,24);

  return dest;
}

/*
function multimenu(x1,x2,y:word; color,items,defitem,coloumns,spacing,align:byte; var texts:array of string):byte;
var h:array[0..4] of integer;
    rows:integer;
    lng,lft,rgt,maxitems,ix,iy,cell:integer;
    i,j,k,l:integer;
    ch:char;
begin
  rows:=items div coloumns;
  if items mod coloumns <> 0 then inc(rows);
  maxitems:=rows*coloumns;
  h[0]:=defitem;
  textattr:=color;
  window(x1,y,x2,y+rows+spacing*(rows+1)+2);
  lng:=(x2-x1)+1;
  cell:=(lng-2) div coloumns;

  rgt:=lng-(length(texts[0])+6);
  lft:=rgt div 2;
  rgt:=rgt-lft;
  write('');
  for i:=1 to lft do write('');
  write(' ',texts[0],' ');
  for i:=1 to rgt do write('');
  write('');

  for i:=1 to rows do begin

    for k:=1 to spacing do begin
      write('');
      for j:=1 to lng-2 do write(' ');
      write('');
    end;

    write('');
    for l:=0 to coloumns-1 do begin
      case align of
        0: begin
             rgt:=cell-length(texts[l*rows+i]);
             lft:=rgt div 2;
             rgt:=rgt-lft;
           end;
        1: begin
             rgt:=cell-length(texts[l*rows+i]);
             if rgt < 0 then rgt:=1;
             lft:=1;
             rgt:=rgt-lft;
           end;
        2: begin
             lft:=cell-length(texts[l*rows+i]);
             if lft < 0 then lft:=1;
             rgt:=1;
             lft:=lft-rgt;
           end;
      end;
      for j:=1 to lft do write(' ');
      write(texts[l*rows+i]);
      for j:=1 to rgt do write(' ');
    end;
    write('');
  end;

  for k:=1 to spacing do begin
    write('');
    for j:=1 to lng-2 do write(' ');
    write('');
  end;

  write('');
  for i:=1 to lng - 2 do write('');
  write('');
  repeat
   h[1]:=h[0]+1; if h[1] > maxitems then h[1]:=1;
   h[2]:=h[0]-1; if h[2] < 1 then h[2]:=maxitems;
   h[3]:=h[0]+rows; if h[3] > maxitems then h[3]:=h[3]-maxitems;
   h[4]:=h[0]-rows; if h[4] < 1 then h[4]:=h[4]+maxitems;
   ix:=h[0] div rows; if h[0] mod rows = 0 then dec(ix);
   iy:=h[0] mod rows; if iy = 0 then iy:=rows;
   highlight(x1+cell*ix+1,x1+cell*(ix+1),y+iy*(spacing+1),31);
   for i:=1 to 4 do begin
     ix:=h[i] div rows; if h[i] mod rows = 0 then dec(ix);
     iy:=h[i] mod rows; if iy = 0 then iy:=rows;
     highlight(x1+cell*ix+1,x1+cell*(ix+1),y+iy*(spacing+1),color);
   end;
   ch:=readkey;
   case ch of
     #00: case readkey of
            #72: if h[0] > 1 then dec(h[0]);
            #80: if h[0] < items then inc(h[0]);
            #75: if h[0] > rows then dec(h[0],rows);
            #77: if h[0] < items-rows+1 then inc(h[0],rows);
          end;
     #13: multimenu:=h[0];
   end;
  until ch = #13;
  window(1,1,80,25);
end;

end.*/
