/* function headers */

#define DIALOG(lines, data) strtoint(dialog(17, 36, 10, lines, 48, data, temp))
#define HEXDIALOG(lines, data) strtohex(dialog(17, 36, 10, lines, 48, data, temp))

/* crt.s */
extern void highlight(int x1, int x2, int y, int atr);
extern int textattr;
extern int clearchar;
extern void clrscr(void);
extern void gotoxy(int x, int y);
extern void write(char *data);
extern void put_char(int ch);
extern void window(int x1, int y1, int x2, int y2);
extern void get_window(int *x1, int *y1, int *x2, int *y2);
extern void save_screen(void);
extern void load_screen(void);
extern void hide_cursor(void);
extern void show_cursor(void);
extern char *inttostr(int src, char *dest);
extern char *hextostr(int src, char *dest);
extern int strtoint(char *src);
extern int strtohex(char *src);
extern char *pad_right(int num, char *dest, int padchar);
extern int readkey(void);
extern void read_enter(void);
extern int read_char(void);
extern char *read_string(char *dest, int size);

/* string.c */
extern int strlen(char *data);
extern char *strcat(char *dest, ...);

/* mymenu.c */
typedef enum {
  AL_CENTER, AL_LEFT, AL_RIGHT
} ALIGN;

typedef struct {
  int ht, it;
} MENU_STATE;

extern void poz(char *u, char *d);
extern int menu(int x1, int x2, int y, int minlines, int color, int defitem, int spacing, ALIGN align, char *texts);
extern int menu_ex(int x1, int x2, int y, int lines, int color, MENU_STATE *m, int items, char *title, char *(*getstr)(), void (*callback)() );
extern void okno(int x1, int x2, int y, int lines, int color, char *head, char *body);
extern void okno_ex(char *body);
extern char *dialog(int x1, int x2, int y, int lines, int color, char *texts, char *dest);

/* descriptor.c */
typedef enum {
  TB_GDT = 0,
  TB_LDT = 1,
  TB_IDT = 2
} TABLE;

typedef struct s_descriptor {
  int type, s, d, g, dpl, p;
  int seg, ofs, pc, sel_min, sel_max;
  TABLE dti;		// Descriptor table indicator
  char *dts;		// Descriptor table string
  int index;
  unsigned int base;
  unsigned int limit;
} DESCRIPTOR;

typedef enum {
  E_CALL = 0,
  E_JMP = 1
} E_TYPE;

typedef struct s_execparam {
  E_TYPE type;
  TABLE dti;		// Descriptor table identifier
  int index;		// Called segment selector index
  int cpl;		// CPL of calling process (will drop privileges to this before call)
  int rpl;		// RPL of called segment
  int module;		// Code module that will be copied into destination code segment
  int pc;		// Module parameters count
} EX_PARAMS;

extern DESCRIPTOR *load_descriptor(int selector, TABLE tab, DESCRIPTOR *d1);
extern void store_descriptor(DESCRIPTOR *d1);
extern void descriptors(void);
extern void ldescriptors(void);
extern void idescriptors(void);
extern void init_menus(void);

/* exec.c */
extern void execute(void);

/* main.s */
extern void rm_reboot(void);
extern void sw_int(int intno);
extern void xdt_read(int selector, int table, unsigned int *data);
extern void xdt_write(int selector, int table, unsigned int *data);
extern int load_ldtr(void);
extern void store_ldtr(int selector);
extern int getcpl(void);
extern void *memcpy(void *dest, void *src, int n);

/* tss.s */
extern void tss_prep(int opcode, int sel, int ofs, int cpl);
extern void tss_call(void);

// modules.c
extern int hide_code;
extern int mod_count;
extern char *mod_iterate(int sel, char *data);
extern void mod_info_display(int num);
extern int mod_setup(int mnum, int snum);
extern int mod_end;

